;Program for selektivt anrop system (selcall)
;Krystall 4Mhz
;av Sondre Danielsen





	LIST    P=16f84

	

_CP_OFF		equ	H'3FFF'			;code protect off
_PWRTE_ON	equ	H'3FFF' 		;Power on timer on
_WDT_OFF	equ	H'3FFB'			;watch dog timer off
_XT_OSC		equ	H'3FFD'			;crystal oscillator
__CONFIG     	_CP_OFF & _PWRTE_ON & _WDT_OFF & _XT_OSC
	


puls	equ	10		;Variabel som inneholder antall leste pulser
teller1	equ	11		;Variabel som inneholder den tiden pulsene skal telles
teller2	equ	12		;Vente variabel
lyd1	equ	13
lyd2	equ	14
lyd3	equ	15
var1	equ	16
var2	equ	17
var3	equ	18
lyd4	equ	19
STATUS                       EQU     H'0003'
PORTA                        EQU     H'0005'
PORTB                        EQU     H'0006'
TRISA                        EQU     H'0085'
TRISB                        EQU     H'0086'



	bsf	status,5		
	clrf	trisb		;setter portb til utg porta til inngang
	bcf	status,5
	clrf	portb
	call	tone1



start	clrf	lyd1		;reset av time out timer

;-------Detektering av tone sekvens---------

;0x10 : 550 - 700 Hz  0x1c : 1,0 - 1,2 Khz  0x2c : 1,6 - 1,8 Khz


comp1	call	test
	xorlw	0x1c		;Frste tone 
	btfss	status,2
	goto	comp1
	call	wait

	call	test
	xorlw	0x1c
	btfss	status,2
	goto	comp1
	call	wait

	call	test
	xorlw	0x1c
	btfss	status,2
	goto	comp1
;	call	tone1		;Brukes under test

comp2	incf	lyd1		;time out timer
	btfsc	status,2
	goto	start
	call	test
	xorlw	0x10		;Andre tone
	btfss	status,2
	goto	comp2
	call	wait

	call	test
	xorlw	0x10
	btfss	status,2
	goto	comp2
	call	wait

	call	test
	xorlw	0x10
	btfss	status,2
	goto	comp2
;	call	tone1		;Brukes under test

comp3	incf	lyd1		;time out timer
	btfsc	status,2
	goto	start
	call	test
	xorlw	0x2c		;Tredje tone
	btfss	status,2
	goto	comp3
	call	wait

	call	test
	xorlw	0x2c
	btfss	status,2
	goto	comp3
	call	wait

	call	test
	xorlw	0x2c
	btfss	status,2
	goto	comp3

;-------Gyldig tone sekvens-------
	
	bsf	portb,0		;TX aktiveres lyd sendes til hyttaler og sender
	bsf	var1,0		;Setter bit for indikator lampe

;	call	tone1		;Gir lyd signal til hyttaler
	call	waitl
	call	tone2
	call	waitl
	call	tone2
	call	waitl
	call	tone2
	bcf	portb,0		;TX deaktiveres

	goto	start


;-------Sending av tone sekvens---------

send	bsf	portb,0		;TX aktiveres
	bcf	var1,0		;Indikator deaktiveres
	call	waitl

	movlw	.119		;Frste tone (117-121)
	movwf	lyd4
	call	lyd	

	movlw	.211		;Andre tone  (206-216)
	movwf	lyd4
	call	lyd
	
	movlw	.75		;Tredje tone (75-76)
	movwf	lyd4
	call	lyd

	bcf	portb,0		;TX deaktiveres
	
	goto	start
	

;-------Telling av pulser----------------

test	btfsc	porta,1		;Sjekker om call inngangen er aktivert
	goto	send
	btfsc	porta,2		;Sjekker om indikator reset er aktivert
	bcf	var1,0
	btfss	var1,0		;Sjekker om indikator skal vre av eller p
	bcf	portb,1

	btfss	var1,0		;Sjekker om indikator skal vre p
	goto	test2

;-Blinke rutine for indikator-	

	btfsc	portb,1
	goto	blink
	movlw	.32		;Av tid
	movwf	var3	
	decfsz	var2
	goto	test2
	bsf	portb,1
	goto	test2	

blink	movlw	.32		;P tid
	movwf	var2	
	decfsz	var3
	goto	test2
	bcf	portb,1
	goto	test2	

;-Blinke rutune slutt-


test2	movlw	0		;bestemmer hvor lenge pulsene skal telles
	movwf	teller1
	clrf	puls
	
lav	call	wait	
	decfsz	teller1		;sjekker om porta,0 er lav , lav gr videre
	goto	lavv
	goto	test1
lavv	btfss	porta,0
	goto	lav

hy	call	wait
	decfsz	teller1		;sjekker om porta,0 er hy , hy gr videre
	goto	hyy
	goto	test1
hyy	btfsc	porta,0
	goto	hy
	
	incf	puls
	goto	lav

test1	movfw	puls
	return




	
;---------Lyd til hyttaler-----

tone2	
	movlw	.39		;Pulserende tone 4x med varierende tone
	movwf	lyd4
	call	lyd
	movlw	.37
	movwf	lyd4
	call	lyd
	movlw	.39
	movwf	lyd4
	call	lyd
	movlw	.37
	movwf	lyd4
	call	lyd
	return

tone1	movlw	.37		;Enkel kort tone
	movwf	lyd4

lyd	movlw	.16		;Hvor lenge lyden skal vare
	movwf	lyd2
lyda	movlw	.69		;Hvor lenge lyden skal vare
	movwf	lyd1
lydb	bsf	portb,2
	call	lydc
	bcf	portb,2
	call	lydc
	decfsz	lyd1
	goto 	lydb
	decfsz	lyd2
	goto	lyda
	return




lydc	movfw	lyd4		;Tonen p lyden 25
	movwf	lyd3
lydd	nop
	decfsz	lyd3
	goto	lydd
	return

;-------Lang vente rutine----------

waitl	movlw	.3		;Hvor lenge (grov)
	movwf	lyd1

waitla	movlw	.256		;Hvor lenge (fin)
	movwf	lyd2

waitlb	clrf	lyd3
waitlc	decfsz	lyd3
	goto 	waitlc
	decfsz	lyd2
	goto	waitlb
	decfsz	lyd1
	goto	waitla
	return

	


;-------Kort vente rutine----------

wait	movlw	.32
	movwf	teller2
waitt	decfsz	teller2
	goto	waitt
	return
	








	END	
